<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: editor/editor.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: editor/editor.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* @file filemanager and editor for level and plugins
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

/** form style editor using json-editor
* @global  */
var form = new Form()
var connected = false

socket.on('connect', function (data) {
  if(connected) {
    console.log("editor reconnected")
    editor.assignUser()
    routing.review()
    return
  }
  
  console.log("editor connected")

  socket.get('game', 'name')
  .then(title => {
    $("#title").text(title + " editor")
    document.title = title + " editor"
    
    //$('#home').parent().attr("href","../../ui", "_self")
    $('#home').parent().attr("href","/ui", "_self")
    $('#control').parent().attr("href","/ui/" + title + "/control/sessions#list", "_self")
    
    main = editor
    editor.game = title
    
    routing = new Routing("/ui/"+ title + "/editor")
    
    editor.init()
    
    editor.collections.level = new Level()
    
    editor.collections.plugins = new Plugins()
    
    return editor.collections.plugins.init()
  })
  .then(result => {
    return editor.updateAll()
  })
  .then(result => {
    return editor.assignUser()
  })
  .then(result => {
    while(!editor.document_ready) {}
    connected = true
    editor.ready()
  })
  .catch(error => {
    console.error(error)
  })
})

socket.on('schema', function (data) {
  for (let plugin in data) {
    if (data[plugin].hasOwnProperty('cue')) {
      editor.collections.level.append(plugin, data[plugin])
    }
  }
})

socket.on('lock', args => {
  editor.lock(args)
})

socket.on('unlock', args => {
  editor.unlock(args)
  routing.review()
})

$(document).ready(() => {
  editor.document_ready = true
})

/**
* specify key shortcuts
* - ctrl+s to save currently open editor
*
*/
$(window).bind('keydown', function (event) {
  if (event.ctrlKey || event.metaKey) {
    switch (String.fromCharCode(event.which).toLowerCase()) {
      case 's':
        event.preventDefault()
        editor.save()
        break
    }
  }
})

window.onbeforeunload = function (event) {
  if (form.changed) {
    event.returnValue = "You have unsaved changes."
  }
}

/**
* Expands Navbar with Level and Plugins and their collections.
* Allows to open, save, close etc.
*
*/
class Editor {
  constructor() {
    this.file_menu = new FileMenu()
    this.collections = {}
    this.document_ready = false
    this.user = {}
  }
  
  /**
   * on socket connect.  
   * clean up navbar/remove elements
   */
  init() {
    $(".collection_menu").remove()
    
    $('#editor_user').on('click', e => {
      console.log("click")
      socket.get('rooms', '')
      .then(msg => {
        console.log(msg)
        let usage = "Current users editing or viewing documents\n\n"
        for(let room in msg) {
          if(Object.keys(msg[room]).length) {
            usage += room.toString() + ":\n"
            for(let id in msg[room]) {
              usage += "- " + msg[room][id].name + " (" + msg[room][id].browser + ') \n'
            }
            usage += "\n"
          }
        }
        Swal({
          title: "Editor User",
          text: usage
        })
      })
    })

    this.unlock()
  }

  /**
   * get user details from server and store them in editor user variable
   * 
   * user was defined on login. If there is no login user is empty
   */
  assignUser() {
    /*
    return new Promise((resolve, reject) => {
      if (typeof(Storage) !== "undefined") {
        if(!localStorage.user) {
          inputPrompt("Bitte gib deinen Namen ein", "", input => {
            localStorage.user = input
            return resolve()
          })
        } else {
          return resolve()
        }
      } else {
        return resolve()
      }
    })
    */
  return new Promise((resolve, reject) => {
    console.log("get user")
    socket.get('user', '')
    .then(result => {
      console.log(result)
      this.user = result
      $("#username").html(this.user.name)
      return resolve()
    })
   })
  }

  /**
  * is called if:
  * 
  * - socket connected  
  * - all collections are populated  
  * - document ready event fired
  */
  ready() {
    console.log("editor ready")
    this.file_menu.disable()
    routing.review()
  }

  /**
   * disable current editor and saving.
   * 
   * Show notification and toggle lock icon to closed.
   *
   * @param {string} msg - notification message to be displayed in alert
   */
  lock(msg) {
    if(!form.locked) {
      form.locked = true
      plaigraph.lock()
      this.file_menu.config({save:false, delete:false})
      console.log("Editor locked")
      $('.lock').addClass('closed').removeClass('open')
      $('.lock').children('.lock').removeClass('fa-lock-open').addClass('fa-lock')
      $('.lock').off('click')
      $('.lock').on('click', e => {
        Swal({
          title: "Editor locked",
          text: msg,
          icon: "warning"
        })
      })
      Swal({
        title: "Editor locked",
        text: msg,
        icon: "warning"
      })
    }
  }

  /**
   * enable current editor and saving.
   * 
   * Show success notification and toggle lock icon to open.
   */
  unlock() {
    if(form.locked) {
      form.locked = false
      plaigraph.unlock()
      this.file_menu.config({save:true, delete:true})
      console.log("Editor unlocked")
      $('.lock').removeClass('closed').addClass('open')
      $('.lock').children('lock').removeClass('fa-lock').addClass('fa-lock-open')
      $('.lock').off('click')
      
      Swal({
        title: "Editor unlocked",
        text: "Editing and saving is enabled",
        icon: "success",
        buttons: false,
        timer: 2500
      })
    }
  }
  
  /**
  * populte all dynamic lists in navbar
  * - level
  * - sessions
  * - plugins
  *
  */
  updateAll() {
    return new Promise((resolve, reject) => {
      var populate_collections = []
      for (let collection in this.collections) {
        populate_collections.push(this.collections[collection].update())
      }
      Promise.all(populate_collections)
      .then(result => {
        console.log("all updated")
        return resolve(result)
      })
      .catch(error => {
        return reject(error)
      })
    })
  }
  
  /**
  * call collections remove function and delete collection instance.
  *
  * @param {string} name - collection name
  */
  removeCollection(name) {
    this.collections[name].$collection_menu.remove()
    delete this.collections[name]
    console.log("collection removed: " + name)
  }
  
  /**
  * REset/Clear form editor and remove current content from DOM.
  */
  closeContent() {
    form.clear()
      .then(confirmed => {
        if (confirmed) {
          this.file_menu.disable()
          this.clearContent()
          // $('#content').html($('#editor_div'))
        } else {
          routing.undo()
        }
      })
  }
  
  /**
  * Clear content container.
  */
  clearContent() {
    $('#editor_div').children().detach()
    $('#content').html($('#editor_div'))
  }
  
  /**
  * call remove function of current content collection.
  * clear content.
  */
  deleteContent() {
    console.log(form)
    this.collections[form.collection].removeDocument(form.title, form.id)
    .then(result => {
      if(result) {
        form.discard()
        this.file_menu.disable()
        this.clearContent()
        routing.show('#empty')
      }
    })
    .catch(error => {
      console.error(error)
    })
  }
  
  /**
  * call socket.save() function with current form content
  * refresh dynamic gui elements and set editor content to unchanged
  * if content was not in database yet, assign auto created ID
  */
  save() {
    if(this.file_menu.getState("save")) {
      socket.save(form.getData(), form.collection)
        .then(result => {
          if (result) {
            if (result.hasOwnProperty('insertedId')) {
              form.assignID(result.insertedId)
            }
            routing.show("/" + form.collection + "/" + form.title + "#edit")
            editor.file_menu.enable()
            form.changed = false
            this.collections[form.collection].update()
            .then(result => {
              $("#content").trigger("save")
              document.cookie = "status=saved"
            })
            .catch(err => {
              console.error(err)
            })
          }
        })
    } else {
      Swal({
        text: "Saving is disabled.",
        icon: "warning",
        buttons: false,
        timer: 2000
      })
    }
  }
  
  /**
  * open file explorer and provide json style (including linebreaks) textfile
  *
  * parts from:
  * https://stackoverflow.com/questions/3665115/create-a-file-in-memory-for-user-to-download-not-through-server/18197341#18197341
  *
  * removes _id property before download for better (re-)import
  * 
  * @param {string} filename - name of file that will be downloaded
  * @param {Object} [data] - json data to be downloaded as a file. If not provided current content is downloaded
  */
  download(filename, data) {
    if (!data) {
      data = form.getData()
    }

    let download_data = Object.assign({}, data)

    if (download_data.hasOwnProperty('_id')) {
      delete download_data._id
    }
    let json_data = JSON.stringify(download_data, null, 2)
    var element = document.createElement('a');
    element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(json_data));
    element.setAttribute('download', filename);

    element.style.display = 'none';
    document.body.appendChild(element);

    element.click();

    document.body.removeChild(element);
  }
  
  /**
  * open file input and
  * get JSON data from chosen file
  *
  * @returns {Promise} json parsed data from file
  */
  import() {
    return new Promise(function (resolve, reject) {
      var $input = $('&lt;input type="file" id="fileinput" />')
      $input.trigger('click')
      $input.on('change', function (e) {
        var fileReader = new FileReader()
        fileReader.onload = function () {
          var data = fileReader.result
          console.log(data)
          try {
            let js_data = JSON.parse(data)
            return resolve(js_data)
          } catch (e) {
            Swal({
              title: "Import failed:",
              text: String(e),
              icon: "warning"
            })
            return reject(e)
          }
        }
        fileReader.onabort = function () {
          console.log("abort")
          //return resolve()
        }
        fileReader.onloadend = function () {
          console.log("end")
          //return resolve()
        }
        fileReader.onerror = function () {
          console.log("error")
          //return resolve()
        }
        fileReader.onloadstart = function () {
          console.log("start")
        }
        fileReader.onprogress = function () {
          console.log("progress")
        }
        fileReader.readAsText($input.prop('files')[0])
      })
    })
  }
}

/**
* Left most navbar element (File) with options to manipulate current editor content.
*
*/
class FileMenu {
  constructor() {
    this.$save = $("#file_save")
    this.$save_as = $("#file_save_as")
    this.$download = $("#file_download")
    this.$schema_download = $("#file_schema_download")
    //this.$close = $("#file_close")
    this.$delete = $("#file_delete")
  }
  
  /**
  * set all file options to enabled
  */
  enable() {
    this.config({save:!form.locked,save_as:true,download:true,schema_download:true,close:true,delete:!form.locked})
  }
  
  /**
  * set all file options to disabled
  */
  disable() {
    this.config({save:false,save_as:false,download:false,schema_download:false,close:false,delete:false})
  }
  
  /**
  * enable or disable specific options
  *
  * @param {Object} options - add properties that are supposed to be enabled (true) or disabled (false)
  * @param {Object} options.save - enable (true) or disable (false) save option
  * @param {Object} options.save_as - enable (true) or disable (false) save_as option
  * @param {Object} options.download - enable (true) or disable (false) download option
  * @param {Object} options.schema_download - enable (true) or disable (false) schema_download option
  * @param {Object} options.delete - enable (true) or disable (false) delete option
  */
  config(options) {
    if(options.hasOwnProperty("save")) {
      this.toggle(this.$save, options.save, event => {
        editor.save()
      })
    }
    if(options.hasOwnProperty("save_as")) {
      this.toggle(this.$save_as, options.save_as, event => {
        inputPrompt("Enter new name for document", form.title + "_copy", function (doc_name) {
          if (doc_name) {
            socket.save(form.getData(), form.collection, doc_name)
              .then(result => {
                if (result) {
                  editor.collections[form.collection].update()
                  routing.open("/" + form.collection + "/" + doc_name + "#edit")
                }
              })
          }
        })
      })
    }
    if(options.hasOwnProperty("download")) {
      this.toggle(this.$download, options.download, event => {
        inputPrompt("Enter Filename", form.title + ".json", function (doc_name) {
          if (doc_name) {
            editor.download(doc_name)
          }
        })
      })
    }
    if(options.hasOwnProperty("schema_download")) {
      this.toggle(this.$schema_download, options.schema_download, event => {
        inputPrompt("Enter Filename for schema", form.title + "_schema.json", function (doc_name) {
          if (doc_name) {
            editor.download(doc_name, editor.collections[form.collection].getSchema())
          }
        })
      })
    }
    
    /*
    if(options.hasOwnProperty("close")) {
      this.toggle(this.$close, options.close, () => {
        editor.routing.add({hash:"empty", link:$("#close")}, e => {
          editor.closeContent()
        })
      })
    }
    */
    if(options.hasOwnProperty("delete")) {
      this.toggle(this.$delete, options.delete, event => {
        editor.deleteContent()
      })
    }
  }
  
  /**
  * add or remove click function from option element
  */
  toggle($elem, state, callback) {
    if(state) {
      if($elem.hasClass('inactive')) {
        $elem.addClass('active').removeClass('inactive')
        $elem.click(callback)
      }
    } else {
      if($elem.hasClass('active')) {
        $elem.removeClass('active').addClass('inactive').off('click')
      }
    }
  }
  
  /**
  * get current state of option
  *
  * @returns {boolean} true if option is enable, false if option is disabled
  */
  getState(elem) {
    return $("#file_" + elem).hasClass('active')
  }
}

/** global editor element */
var editor = new Editor()
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
